/**
 * Created by yuanjianxin on 2018/5/10.
 */
const Web3=require('web3');
const Tx=require('ethereumjs-tx');
module.exports={


    getFormatedTx(eth,to,funcName,gasLimit=null,types=[],args=[]){
        let fullName=funcName+'('+types.join()+')';
        let signature=Web3.utils.sha3(fullName).substr(2,8);
        let data='0x'+signature+Web3.eth.abi.encodeParameters(types,args);
        let nonce=Web3.utils.toHex(eth.getTransactionCount(to))
        let gasPrice=Web3.utils.toHex(eth.gasPrice);
        let gasLimitHex=gasLimit && Web3.utils.toHex(gasLimit) || null;
        let rawTx={nonce,gasPrice,to,data};
        gasLimitHex && (rawTx.gasLimit=gasLimitHex);
        return new Tx(rawTx);
    },


    async sendRawTransaction(eth,tx){
        let serializedTx='0x'+tx.serialize().toString('hex');
        return new Promise((resolve,reject)=>{
            eth.sendRawTransaction(serializedTx,(err,res)=>{
                err ? reject(err) : resolve(res);
            });
        });
    }

}